// cl crt_win_w.cpp /O1 /Os /GS- /c /W3 /DWIN32_LEAN_AND_MEAN
#include <windows.h>
#pragma comment(linker, "/defaultlib:kernel32.lib")
#pragma comment(linker, "/nodefaultlib:libc.lib")
#pragma comment(linker, "/nodefaultlib:libcmt.lib")
int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int);

extern "C" void __cdecl wWinMainCRTStartup(void)
{
 int iReturn = wWinMain(GetModuleHandle(NULL),NULL,NULL,SW_SHOWDEFAULT);
 ExitProcess(iReturn);
}









/*
// cl crt_winw.cpp /c /W3 /DWIN32_LEAN_AND_MEAN
#include <windows.h>
#pragma comment(linker, "/defaultlib:kernel32.lib")  // Force the linker to include KERNEL32.LIB
#pragma comment(linker, "/nodefaultlib:libc.lib")
#pragma comment(linker, "/nodefaultlib:libcmt.lib")
int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR, int);

extern "C" void __cdecl wWinMainCRTStartup( void )

{
    int mainret;
    wchar_t* lpszCommandLine;
    STARTUPINFOW StartupInfo;

    lpszCommandLine = GetCommandLine();

    // Skip past program name (first token in command line).

    if ( *lpszCommandLine == '"' )  // Check for and handle quoted program name
    {
		lpszCommandLine++;	// Get past the first quote

        // Now, scan, and skip over, subsequent characters until  another
        // double-quote or a null is encountered
        while( *lpszCommandLine && (*lpszCommandLine != '"') )
            lpszCommandLine++;

        // If we stopped on a double-quote (usual case), skip over it.

        if ( *lpszCommandLine == '"' )
            lpszCommandLine++;
    }
    else    // First token wasn't a quote
    {
        while ( *lpszCommandLine > ' ' )
            lpszCommandLine++;
    }

    // Skip past any white space preceeding the second token.

    while ( *lpszCommandLine && (*lpszCommandLine <= ' ') )
        lpszCommandLine++;

    StartupInfo.dwFlags = 0;
    GetStartupInfo( &StartupInfo );

    // set up our minimal cheezy atexit table
    _atexit_init();

    // Call C++ constructors
    _initterm( __xc_a, __xc_z );

    mainret=WinMain(GetModuleHandle(NULL),NULL,lpszCommandLine,StartupInfo.dwFlags & STARTF_USESHOWWINDOW ? StartupInfo.wShowWindow : SW_SHOWDEFAULT);

    _DoExit();

    ExitProcess(mainret);
}
*/

/*
typedef struct _STARTUPINFOA 
{
 DWORD   cb;
 LPSTR   lpReserved;
 LPSTR   lpDesktop;
 LPSTR   lpTitle;
 DWORD   dwX;
 DWORD   dwY;
 DWORD   dwXSize;
 DWORD   dwYSize;
 DWORD   dwXCountChars;
 DWORD   dwYCountChars;
 DWORD   dwFillAttribute;
 DWORD   dwFlags;
 WORD    wShowWindow;
 WORD    cbReserved2;
 LPBYTE  lpReserved2;
 HANDLE  hStdInput;
 HANDLE  hStdOutput;
 HANDLE  hStdError;
} STARTUPINFOA, *LPSTARTUPINFOA;

typedef struct _STARTUPINFOW 
{
 DWORD   cb;
 LPWSTR  lpReserved;
 LPWSTR  lpDesktop;
 LPWSTR  lpTitle;
 DWORD   dwX;
 DWORD   dwY;
 DWORD   dwXSize;
 DWORD   dwYSize;
 DWORD   dwXCountChars;
 DWORD   dwYCountChars;
 DWORD   dwFillAttribute;
 DWORD   dwFlags;
 WORD    wShowWindow;
 WORD    cbReserved2;
 LPBYTE  lpReserved2;
 HANDLE  hStdInput;
 HANDLE  hStdOutput;
 HANDLE  hStdError;
} STARTUPINFOW, *LPSTARTUPINFOW;

#ifdef UNICODE
   typedef STARTUPINFOW STARTUPINFO;
   typedef LPSTARTUPINFOW LPSTARTUPINFO;
#else
   typedef STARTUPINFOA STARTUPINFO;
   typedef LPSTARTUPINFOA LPSTARTUPINFO;
#endif // UNICODE



GetCommandLine   The GetCommandLine function returns a pointer to the command-line string 
for the current process. 

LPTSTR GetCommandLine(VOID)
 
Parameters       This function has no parameters. 

Return Values    The return value is a pointer to the command-line string for the current process. 

Remarks          ANSI console processes written in C can use the argc and argv arguments of the main 
                 function to access the command-line arguments. ANSI GUI applications can use the 
                 lpCmdLine parameter of the WinMain function to access the command-line string, 
                 excluding the program name. The reason that main and WinMain cannot return Unicode 
                 strings is that argc, argv, and lpCmdLine use the LPSTR data type for parameters, 
                 not the LPTSTR data type. The GetCommandLine function can be used to access Unicode 
                 strings, because it uses the LPTSTR data type. 

QuickInfo
  Windows NT: Requires version 3.1 or later.
  Windows: Requires Windows 95 or later.
  Windows CE: Unsupported.
  Header: Declared in winbase.h.
  Import Library: Use kernel32.lib.
  Unicode: Implemented as Unicode and ANSI versions on Windows and Windows NT.
*/
